/* SPDX-License-Identifier: BSD-3-Clause */
/*
 * Cadence DDR Driver
 *
 * Copyright (C) 2012-2022 Cadence Design Systems, Inc.
 * Copyright (C) 2018-2022 Texas Instruments Incorporated - https://www.ti.com/
 */

#ifndef REG_LPDDR4_CTL_REGS_H_
#define REG_LPDDR4_CTL_REGS_H_

#include "lpddr4_ddr_controller_macros.h"
#include "lpddr4_pi_macros.h"
#include "lpddr4_data_slice_0_macros.h"
#include "lpddr4_data_slice_1_macros.h"
#include "lpddr4_data_slice_2_macros.h"
#include "lpddr4_data_slice_3_macros.h"
#include "lpddr4_address_slice_0_macros.h"
#include "lpddr4_address_slice_1_macros.h"
#include "lpddr4_address_slice_2_macros.h"
#include "lpddr4_phy_core_macros.h"

typedef struct __attribute__((packed)) lpddr4_ctlregs_s {
	volatile u32 DENALI_CTL_0;
	volatile u32 DENALI_CTL_1;
	volatile u32 DENALI_CTL_2;
	volatile u32 DENALI_CTL_3;
	volatile u32 DENALI_CTL_4;
	volatile u32 DENALI_CTL_5;
	volatile u32 DENALI_CTL_6;
	volatile u32 DENALI_CTL_7;
	volatile u32 DENALI_CTL_8;
	volatile u32 DENALI_CTL_9;
	volatile u32 DENALI_CTL_10;
	volatile u32 DENALI_CTL_11;
	volatile u32 DENALI_CTL_12;
	volatile u32 DENALI_CTL_13;
	volatile u32 DENALI_CTL_14;
	volatile u32 DENALI_CTL_15;
	volatile u32 DENALI_CTL_16;
	volatile u32 DENALI_CTL_17;
	volatile u32 DENALI_CTL_18;
	volatile u32 DENALI_CTL_19;
	volatile u32 DENALI_CTL_20;
	volatile u32 DENALI_CTL_21;
	volatile u32 DENALI_CTL_22;
	volatile u32 DENALI_CTL_23;
	volatile u32 DENALI_CTL_24;
	volatile u32 DENALI_CTL_25;
	volatile u32 DENALI_CTL_26;
	volatile u32 DENALI_CTL_27;
	volatile u32 DENALI_CTL_28;
	volatile u32 DENALI_CTL_29;
	volatile u32 DENALI_CTL_30;
	volatile u32 DENALI_CTL_31;
	volatile u32 DENALI_CTL_32;
	volatile u32 DENALI_CTL_33;
	volatile u32 DENALI_CTL_34;
	volatile u32 DENALI_CTL_35;
	volatile u32 DENALI_CTL_36;
	volatile u32 DENALI_CTL_37;
	volatile u32 DENALI_CTL_38;
	volatile u32 DENALI_CTL_39;
	volatile u32 DENALI_CTL_40;
	volatile u32 DENALI_CTL_41;
	volatile u32 DENALI_CTL_42;
	volatile u32 DENALI_CTL_43;
	volatile u32 DENALI_CTL_44;
	volatile u32 DENALI_CTL_45;
	volatile u32 DENALI_CTL_46;
	volatile u32 DENALI_CTL_47;
	volatile u32 DENALI_CTL_48;
	volatile u32 DENALI_CTL_49;
	volatile u32 DENALI_CTL_50;
	volatile u32 DENALI_CTL_51;
	volatile u32 DENALI_CTL_52;
	volatile u32 DENALI_CTL_53;
	volatile u32 DENALI_CTL_54;
	volatile u32 DENALI_CTL_55;
	volatile u32 DENALI_CTL_56;
	volatile u32 DENALI_CTL_57;
	volatile u32 DENALI_CTL_58;
	volatile u32 DENALI_CTL_59;
	volatile u32 DENALI_CTL_60;
	volatile u32 DENALI_CTL_61;
	volatile u32 DENALI_CTL_62;
	volatile u32 DENALI_CTL_63;
	volatile u32 DENALI_CTL_64;
	volatile u32 DENALI_CTL_65;
	volatile u32 DENALI_CTL_66;
	volatile u32 DENALI_CTL_67;
	volatile u32 DENALI_CTL_68;
	volatile u32 DENALI_CTL_69;
	volatile u32 DENALI_CTL_70;
	volatile u32 DENALI_CTL_71;
	volatile u32 DENALI_CTL_72;
	volatile u32 DENALI_CTL_73;
	volatile u32 DENALI_CTL_74;
	volatile u32 DENALI_CTL_75;
	volatile u32 DENALI_CTL_76;
	volatile u32 DENALI_CTL_77;
	volatile u32 DENALI_CTL_78;
	volatile u32 DENALI_CTL_79;
	volatile u32 DENALI_CTL_80;
	volatile u32 DENALI_CTL_81;
	volatile u32 DENALI_CTL_82;
	volatile u32 DENALI_CTL_83;
	volatile u32 DENALI_CTL_84;
	volatile u32 DENALI_CTL_85;
	volatile u32 DENALI_CTL_86;
	volatile u32 DENALI_CTL_87;
	volatile u32 DENALI_CTL_88;
	volatile u32 DENALI_CTL_89;
	volatile u32 DENALI_CTL_90;
	volatile u32 DENALI_CTL_91;
	volatile u32 DENALI_CTL_92;
	volatile u32 DENALI_CTL_93;
	volatile u32 DENALI_CTL_94;
	volatile u32 DENALI_CTL_95;
	volatile u32 DENALI_CTL_96;
	volatile u32 DENALI_CTL_97;
	volatile u32 DENALI_CTL_98;
	volatile u32 DENALI_CTL_99;
	volatile u32 DENALI_CTL_100;
	volatile u32 DENALI_CTL_101;
	volatile u32 DENALI_CTL_102;
	volatile u32 DENALI_CTL_103;
	volatile u32 DENALI_CTL_104;
	volatile u32 DENALI_CTL_105;
	volatile u32 DENALI_CTL_106;
	volatile u32 DENALI_CTL_107;
	volatile u32 DENALI_CTL_108;
	volatile u32 DENALI_CTL_109;
	volatile u32 DENALI_CTL_110;
	volatile u32 DENALI_CTL_111;
	volatile u32 DENALI_CTL_112;
	volatile u32 DENALI_CTL_113;
	volatile u32 DENALI_CTL_114;
	volatile u32 DENALI_CTL_115;
	volatile u32 DENALI_CTL_116;
	volatile u32 DENALI_CTL_117;
	volatile u32 DENALI_CTL_118;
	volatile u32 DENALI_CTL_119;
	volatile u32 DENALI_CTL_120;
	volatile u32 DENALI_CTL_121;
	volatile u32 DENALI_CTL_122;
	volatile u32 DENALI_CTL_123;
	volatile u32 DENALI_CTL_124;
	volatile u32 DENALI_CTL_125;
	volatile u32 DENALI_CTL_126;
	volatile u32 DENALI_CTL_127;
	volatile u32 DENALI_CTL_128;
	volatile u32 DENALI_CTL_129;
	volatile u32 DENALI_CTL_130;
	volatile u32 DENALI_CTL_131;
	volatile u32 DENALI_CTL_132;
	volatile u32 DENALI_CTL_133;
	volatile u32 DENALI_CTL_134;
	volatile u32 DENALI_CTL_135;
	volatile u32 DENALI_CTL_136;
	volatile u32 DENALI_CTL_137;
	volatile u32 DENALI_CTL_138;
	volatile u32 DENALI_CTL_139;
	volatile u32 DENALI_CTL_140;
	volatile u32 DENALI_CTL_141;
	volatile u32 DENALI_CTL_142;
	volatile u32 DENALI_CTL_143;
	volatile u32 DENALI_CTL_144;
	volatile u32 DENALI_CTL_145;
	volatile u32 DENALI_CTL_146;
	volatile u32 DENALI_CTL_147;
	volatile u32 DENALI_CTL_148;
	volatile u32 DENALI_CTL_149;
	volatile u32 DENALI_CTL_150;
	volatile u32 DENALI_CTL_151;
	volatile u32 DENALI_CTL_152;
	volatile u32 DENALI_CTL_153;
	volatile u32 DENALI_CTL_154;
	volatile u32 DENALI_CTL_155;
	volatile u32 DENALI_CTL_156;
	volatile u32 DENALI_CTL_157;
	volatile u32 DENALI_CTL_158;
	volatile u32 DENALI_CTL_159;
	volatile u32 DENALI_CTL_160;
	volatile u32 DENALI_CTL_161;
	volatile u32 DENALI_CTL_162;
	volatile u32 DENALI_CTL_163;
	volatile u32 DENALI_CTL_164;
	volatile u32 DENALI_CTL_165;
	volatile u32 DENALI_CTL_166;
	volatile u32 DENALI_CTL_167;
	volatile u32 DENALI_CTL_168;
	volatile u32 DENALI_CTL_169;
	volatile u32 DENALI_CTL_170;
	volatile u32 DENALI_CTL_171;
	volatile u32 DENALI_CTL_172;
	volatile u32 DENALI_CTL_173;
	volatile u32 DENALI_CTL_174;
	volatile u32 DENALI_CTL_175;
	volatile u32 DENALI_CTL_176;
	volatile u32 DENALI_CTL_177;
	volatile u32 DENALI_CTL_178;
	volatile u32 DENALI_CTL_179;
	volatile u32 DENALI_CTL_180;
	volatile u32 DENALI_CTL_181;
	volatile u32 DENALI_CTL_182;
	volatile u32 DENALI_CTL_183;
	volatile u32 DENALI_CTL_184;
	volatile u32 DENALI_CTL_185;
	volatile u32 DENALI_CTL_186;
	volatile u32 DENALI_CTL_187;
	volatile u32 DENALI_CTL_188;
	volatile u32 DENALI_CTL_189;
	volatile u32 DENALI_CTL_190;
	volatile u32 DENALI_CTL_191;
	volatile u32 DENALI_CTL_192;
	volatile u32 DENALI_CTL_193;
	volatile u32 DENALI_CTL_194;
	volatile u32 DENALI_CTL_195;
	volatile u32 DENALI_CTL_196;
	volatile u32 DENALI_CTL_197;
	volatile u32 DENALI_CTL_198;
	volatile u32 DENALI_CTL_199;
	volatile u32 DENALI_CTL_200;
	volatile u32 DENALI_CTL_201;
	volatile u32 DENALI_CTL_202;
	volatile u32 DENALI_CTL_203;
	volatile u32 DENALI_CTL_204;
	volatile u32 DENALI_CTL_205;
	volatile u32 DENALI_CTL_206;
	volatile u32 DENALI_CTL_207;
	volatile u32 DENALI_CTL_208;
	volatile u32 DENALI_CTL_209;
	volatile u32 DENALI_CTL_210;
	volatile u32 DENALI_CTL_211;
	volatile u32 DENALI_CTL_212;
	volatile u32 DENALI_CTL_213;
	volatile u32 DENALI_CTL_214;
	volatile u32 DENALI_CTL_215;
	volatile u32 DENALI_CTL_216;
	volatile u32 DENALI_CTL_217;
	volatile u32 DENALI_CTL_218;
	volatile u32 DENALI_CTL_219;
	volatile u32 DENALI_CTL_220;
	volatile u32 DENALI_CTL_221;
	volatile u32 DENALI_CTL_222;
	volatile u32 DENALI_CTL_223;
	volatile u32 DENALI_CTL_224;
	volatile u32 DENALI_CTL_225;
	volatile u32 DENALI_CTL_226;
	volatile u32 DENALI_CTL_227;
	volatile u32 DENALI_CTL_228;
	volatile u32 DENALI_CTL_229;
	volatile u32 DENALI_CTL_230;
	volatile u32 DENALI_CTL_231;
	volatile u32 DENALI_CTL_232;
	volatile u32 DENALI_CTL_233;
	volatile u32 DENALI_CTL_234;
	volatile u32 DENALI_CTL_235;
	volatile u32 DENALI_CTL_236;
	volatile u32 DENALI_CTL_237;
	volatile u32 DENALI_CTL_238;
	volatile u32 DENALI_CTL_239;
	volatile u32 DENALI_CTL_240;
	volatile u32 DENALI_CTL_241;
	volatile u32 DENALI_CTL_242;
	volatile u32 DENALI_CTL_243;
	volatile u32 DENALI_CTL_244;
	volatile u32 DENALI_CTL_245;
	volatile u32 DENALI_CTL_246;
	volatile u32 DENALI_CTL_247;
	volatile u32 DENALI_CTL_248;
	volatile u32 DENALI_CTL_249;
	volatile u32 DENALI_CTL_250;
	volatile u32 DENALI_CTL_251;
	volatile u32 DENALI_CTL_252;
	volatile u32 DENALI_CTL_253;
	volatile u32 DENALI_CTL_254;
	volatile u32 DENALI_CTL_255;
	volatile u32 DENALI_CTL_256;
	volatile u32 DENALI_CTL_257;
	volatile u32 DENALI_CTL_258;
	volatile u32 DENALI_CTL_259;
	volatile u32 DENALI_CTL_260;
	volatile u32 DENALI_CTL_261;
	volatile u32 DENALI_CTL_262;
	volatile u32 DENALI_CTL_263;
	volatile u32 DENALI_CTL_264;
	volatile u32 DENALI_CTL_265;
	volatile u32 DENALI_CTL_266;
	volatile u32 DENALI_CTL_267;
	volatile u32 DENALI_CTL_268;
	volatile u32 DENALI_CTL_269;
	volatile u32 DENALI_CTL_270;
	volatile u32 DENALI_CTL_271;
	volatile u32 DENALI_CTL_272;
	volatile u32 DENALI_CTL_273;
	volatile u32 DENALI_CTL_274;
	volatile u32 DENALI_CTL_275;
	volatile u32 DENALI_CTL_276;
	volatile u32 DENALI_CTL_277;
	volatile u32 DENALI_CTL_278;
	volatile u32 DENALI_CTL_279;
	volatile u32 DENALI_CTL_280;
	volatile u32 DENALI_CTL_281;
	volatile u32 DENALI_CTL_282;
	volatile u32 DENALI_CTL_283;
	volatile u32 DENALI_CTL_284;
	volatile u32 DENALI_CTL_285;
	volatile u32 DENALI_CTL_286;
	volatile u32 DENALI_CTL_287;
	volatile u32 DENALI_CTL_288;
	volatile u32 DENALI_CTL_289;
	volatile u32 DENALI_CTL_290;
	volatile u32 DENALI_CTL_291;
	volatile u32 DENALI_CTL_292;
	volatile u32 DENALI_CTL_293;
	volatile u32 DENALI_CTL_294;
	volatile u32 DENALI_CTL_295;
	volatile u32 DENALI_CTL_296;
	volatile u32 DENALI_CTL_297;
	volatile u32 DENALI_CTL_298;
	volatile u32 DENALI_CTL_299;
	volatile u32 DENALI_CTL_300;
	volatile u32 DENALI_CTL_301;
	volatile u32 DENALI_CTL_302;
	volatile u32 DENALI_CTL_303;
	volatile u32 DENALI_CTL_304;
	volatile u32 DENALI_CTL_305;
	volatile u32 DENALI_CTL_306;
	volatile u32 DENALI_CTL_307;
	volatile u32 DENALI_CTL_308;
	volatile u32 DENALI_CTL_309;
	volatile u32 DENALI_CTL_310;
	volatile u32 DENALI_CTL_311;
	volatile u32 DENALI_CTL_312;
	volatile u32 DENALI_CTL_313;
	volatile u32 DENALI_CTL_314;
	volatile u32 DENALI_CTL_315;
	volatile u32 DENALI_CTL_316;
	volatile u32 DENALI_CTL_317;
	volatile u32 DENALI_CTL_318;
	volatile u32 DENALI_CTL_319;
	volatile u32 DENALI_CTL_320;
	volatile u32 DENALI_CTL_321;
	volatile u32 DENALI_CTL_322;
	volatile u32 DENALI_CTL_323;
	volatile u32 DENALI_CTL_324;
	volatile u32 DENALI_CTL_325;
	volatile u32 DENALI_CTL_326;
	volatile u32 DENALI_CTL_327;
	volatile u32 DENALI_CTL_328;
	volatile u32 DENALI_CTL_329;
	volatile u32 DENALI_CTL_330;
	volatile u32 DENALI_CTL_331;
	volatile u32 DENALI_CTL_332;
	volatile u32 DENALI_CTL_333;
	volatile u32 DENALI_CTL_334;
	volatile u32 DENALI_CTL_335;
	volatile u32 DENALI_CTL_336;
	volatile u32 DENALI_CTL_337;
	volatile u32 DENALI_CTL_338;
	volatile u32 DENALI_CTL_339;
	volatile u32 DENALI_CTL_340;
	volatile u32 DENALI_CTL_341;
	volatile u32 DENALI_CTL_342;
	volatile u32 DENALI_CTL_343;
	volatile u32 DENALI_CTL_344;
	volatile u32 DENALI_CTL_345;
	volatile u32 DENALI_CTL_346;
	volatile u32 DENALI_CTL_347;
	volatile u32 DENALI_CTL_348;
	volatile u32 DENALI_CTL_349;
	volatile u32 DENALI_CTL_350;
	volatile u32 DENALI_CTL_351;
	volatile u32 DENALI_CTL_352;
	volatile u32 DENALI_CTL_353;
	volatile u32 DENALI_CTL_354;
	volatile u32 DENALI_CTL_355;
	volatile u32 DENALI_CTL_356;
	volatile u32 DENALI_CTL_357;
	volatile u32 DENALI_CTL_358;
	volatile u32 DENALI_CTL_359;
	volatile u32 DENALI_CTL_360;
	volatile u32 DENALI_CTL_361;
	volatile u32 DENALI_CTL_362;
	volatile u32 DENALI_CTL_363;
	volatile u32 DENALI_CTL_364;
	volatile u32 DENALI_CTL_365;
	volatile u32 DENALI_CTL_366;
	volatile u32 DENALI_CTL_367;
	volatile u32 DENALI_CTL_368;
	volatile u32 DENALI_CTL_369;
	volatile u32 DENALI_CTL_370;
	volatile u32 DENALI_CTL_371;
	volatile u32 DENALI_CTL_372;
	volatile u32 DENALI_CTL_373;
	volatile u32 DENALI_CTL_374;
	volatile u32 DENALI_CTL_375;
	volatile u32 DENALI_CTL_376;
	volatile u32 DENALI_CTL_377;
	volatile u32 DENALI_CTL_378;
	volatile u32 DENALI_CTL_379;
	volatile u32 DENALI_CTL_380;
	volatile u32 DENALI_CTL_381;
	volatile u32 DENALI_CTL_382;
	volatile u32 DENALI_CTL_383;
	volatile u32 DENALI_CTL_384;
	volatile u32 DENALI_CTL_385;
	volatile u32 DENALI_CTL_386;
	volatile u32 DENALI_CTL_387;
	volatile u32 DENALI_CTL_388;
	volatile u32 DENALI_CTL_389;
	volatile u32 DENALI_CTL_390;
	volatile u32 DENALI_CTL_391;
	volatile u32 DENALI_CTL_392;
	volatile u32 DENALI_CTL_393;
	volatile u32 DENALI_CTL_394;
	volatile u32 DENALI_CTL_395;
	volatile u32 DENALI_CTL_396;
	volatile u32 DENALI_CTL_397;
	volatile u32 DENALI_CTL_398;
	volatile u32 DENALI_CTL_399;
	volatile u32 DENALI_CTL_400;
	volatile u32 DENALI_CTL_401;
	volatile u32 DENALI_CTL_402;
	volatile u32 DENALI_CTL_403;
	volatile u32 DENALI_CTL_404;
	volatile u32 DENALI_CTL_405;
	volatile u32 DENALI_CTL_406;
	volatile u32 DENALI_CTL_407;
	volatile u32 DENALI_CTL_408;
	volatile u32 DENALI_CTL_409;
	volatile u32 DENALI_CTL_410;
	volatile u32 DENALI_CTL_411;
	volatile u32 DENALI_CTL_412;
	volatile u32 DENALI_CTL_413;
	volatile u32 DENALI_CTL_414;
	volatile u32 DENALI_CTL_415;
	volatile u32 DENALI_CTL_416;
	volatile u32 DENALI_CTL_417;
	volatile u32 DENALI_CTL_418;
	volatile u32 DENALI_CTL_419;
	volatile u32 DENALI_CTL_420;
	volatile u32 DENALI_CTL_421;
	volatile u32 DENALI_CTL_422;
	volatile u32 DENALI_CTL_423;
	volatile u32 DENALI_CTL_424;
	volatile u32 DENALI_CTL_425;
	volatile u32 DENALI_CTL_426;
	volatile u32 DENALI_CTL_427;
	volatile u32 DENALI_CTL_428;
	volatile u32 DENALI_CTL_429;
	volatile u32 DENALI_CTL_430;
	volatile u32 DENALI_CTL_431;
	volatile u32 DENALI_CTL_432;
	volatile u32 DENALI_CTL_433;
	volatile u32 DENALI_CTL_434;
	volatile char pad__0[0x1934U];
	volatile u32 DENALI_PI_0;
	volatile u32 DENALI_PI_1;
	volatile u32 DENALI_PI_2;
	volatile u32 DENALI_PI_3;
	volatile u32 DENALI_PI_4;
	volatile u32 DENALI_PI_5;
	volatile u32 DENALI_PI_6;
	volatile u32 DENALI_PI_7;
	volatile u32 DENALI_PI_8;
	volatile u32 DENALI_PI_9;
	volatile u32 DENALI_PI_10;
	volatile u32 DENALI_PI_11;
	volatile u32 DENALI_PI_12;
	volatile u32 DENALI_PI_13;
	volatile u32 DENALI_PI_14;
	volatile u32 DENALI_PI_15;
	volatile u32 DENALI_PI_16;
	volatile u32 DENALI_PI_17;
	volatile u32 DENALI_PI_18;
	volatile u32 DENALI_PI_19;
	volatile u32 DENALI_PI_20;
	volatile u32 DENALI_PI_21;
	volatile u32 DENALI_PI_22;
	volatile u32 DENALI_PI_23;
	volatile u32 DENALI_PI_24;
	volatile u32 DENALI_PI_25;
	volatile u32 DENALI_PI_26;
	volatile u32 DENALI_PI_27;
	volatile u32 DENALI_PI_28;
	volatile u32 DENALI_PI_29;
	volatile u32 DENALI_PI_30;
	volatile u32 DENALI_PI_31;
	volatile u32 DENALI_PI_32;
	volatile u32 DENALI_PI_33;
	volatile u32 DENALI_PI_34;
	volatile u32 DENALI_PI_35;
	volatile u32 DENALI_PI_36;
	volatile u32 DENALI_PI_37;
	volatile u32 DENALI_PI_38;
	volatile u32 DENALI_PI_39;
	volatile u32 DENALI_PI_40;
	volatile u32 DENALI_PI_41;
	volatile u32 DENALI_PI_42;
	volatile u32 DENALI_PI_43;
	volatile u32 DENALI_PI_44;
	volatile u32 DENALI_PI_45;
	volatile u32 DENALI_PI_46;
	volatile u32 DENALI_PI_47;
	volatile u32 DENALI_PI_48;
	volatile u32 DENALI_PI_49;
	volatile u32 DENALI_PI_50;
	volatile u32 DENALI_PI_51;
	volatile u32 DENALI_PI_52;
	volatile u32 DENALI_PI_53;
	volatile u32 DENALI_PI_54;
	volatile u32 DENALI_PI_55;
	volatile u32 DENALI_PI_56;
	volatile u32 DENALI_PI_57;
	volatile u32 DENALI_PI_58;
	volatile u32 DENALI_PI_59;
	volatile u32 DENALI_PI_60;
	volatile u32 DENALI_PI_61;
	volatile u32 DENALI_PI_62;
	volatile u32 DENALI_PI_63;
	volatile u32 DENALI_PI_64;
	volatile u32 DENALI_PI_65;
	volatile u32 DENALI_PI_66;
	volatile u32 DENALI_PI_67;
	volatile u32 DENALI_PI_68;
	volatile u32 DENALI_PI_69;
	volatile u32 DENALI_PI_70;
	volatile u32 DENALI_PI_71;
	volatile u32 DENALI_PI_72;
	volatile u32 DENALI_PI_73;
	volatile u32 DENALI_PI_74;
	volatile u32 DENALI_PI_75;
	volatile u32 DENALI_PI_76;
	volatile u32 DENALI_PI_77;
	volatile u32 DENALI_PI_78;
	volatile u32 DENALI_PI_79;
	volatile u32 DENALI_PI_80;
	volatile u32 DENALI_PI_81;
	volatile u32 DENALI_PI_82;
	volatile u32 DENALI_PI_83;
	volatile u32 DENALI_PI_84;
	volatile u32 DENALI_PI_85;
	volatile u32 DENALI_PI_86;
	volatile u32 DENALI_PI_87;
	volatile u32 DENALI_PI_88;
	volatile u32 DENALI_PI_89;
	volatile u32 DENALI_PI_90;
	volatile u32 DENALI_PI_91;
	volatile u32 DENALI_PI_92;
	volatile u32 DENALI_PI_93;
	volatile u32 DENALI_PI_94;
	volatile u32 DENALI_PI_95;
	volatile u32 DENALI_PI_96;
	volatile u32 DENALI_PI_97;
	volatile u32 DENALI_PI_98;
	volatile u32 DENALI_PI_99;
	volatile u32 DENALI_PI_100;
	volatile u32 DENALI_PI_101;
	volatile u32 DENALI_PI_102;
	volatile u32 DENALI_PI_103;
	volatile u32 DENALI_PI_104;
	volatile u32 DENALI_PI_105;
	volatile u32 DENALI_PI_106;
	volatile u32 DENALI_PI_107;
	volatile u32 DENALI_PI_108;
	volatile u32 DENALI_PI_109;
	volatile u32 DENALI_PI_110;
	volatile u32 DENALI_PI_111;
	volatile u32 DENALI_PI_112;
	volatile u32 DENALI_PI_113;
	volatile u32 DENALI_PI_114;
	volatile u32 DENALI_PI_115;
	volatile u32 DENALI_PI_116;
	volatile u32 DENALI_PI_117;
	volatile u32 DENALI_PI_118;
	volatile u32 DENALI_PI_119;
	volatile u32 DENALI_PI_120;
	volatile u32 DENALI_PI_121;
	volatile u32 DENALI_PI_122;
	volatile u32 DENALI_PI_123;
	volatile u32 DENALI_PI_124;
	volatile u32 DENALI_PI_125;
	volatile u32 DENALI_PI_126;
	volatile u32 DENALI_PI_127;
	volatile u32 DENALI_PI_128;
	volatile u32 DENALI_PI_129;
	volatile u32 DENALI_PI_130;
	volatile u32 DENALI_PI_131;
	volatile u32 DENALI_PI_132;
	volatile u32 DENALI_PI_133;
	volatile u32 DENALI_PI_134;
	volatile u32 DENALI_PI_135;
	volatile u32 DENALI_PI_136;
	volatile u32 DENALI_PI_137;
	volatile u32 DENALI_PI_138;
	volatile u32 DENALI_PI_139;
	volatile u32 DENALI_PI_140;
	volatile u32 DENALI_PI_141;
	volatile u32 DENALI_PI_142;
	volatile u32 DENALI_PI_143;
	volatile u32 DENALI_PI_144;
	volatile u32 DENALI_PI_145;
	volatile u32 DENALI_PI_146;
	volatile u32 DENALI_PI_147;
	volatile u32 DENALI_PI_148;
	volatile u32 DENALI_PI_149;
	volatile u32 DENALI_PI_150;
	volatile u32 DENALI_PI_151;
	volatile u32 DENALI_PI_152;
	volatile u32 DENALI_PI_153;
	volatile u32 DENALI_PI_154;
	volatile u32 DENALI_PI_155;
	volatile u32 DENALI_PI_156;
	volatile u32 DENALI_PI_157;
	volatile u32 DENALI_PI_158;
	volatile u32 DENALI_PI_159;
	volatile u32 DENALI_PI_160;
	volatile u32 DENALI_PI_161;
	volatile u32 DENALI_PI_162;
	volatile u32 DENALI_PI_163;
	volatile u32 DENALI_PI_164;
	volatile u32 DENALI_PI_165;
	volatile u32 DENALI_PI_166;
	volatile u32 DENALI_PI_167;
	volatile u32 DENALI_PI_168;
	volatile u32 DENALI_PI_169;
	volatile u32 DENALI_PI_170;
	volatile u32 DENALI_PI_171;
	volatile u32 DENALI_PI_172;
	volatile u32 DENALI_PI_173;
	volatile u32 DENALI_PI_174;
	volatile u32 DENALI_PI_175;
	volatile u32 DENALI_PI_176;
	volatile u32 DENALI_PI_177;
	volatile u32 DENALI_PI_178;
	volatile u32 DENALI_PI_179;
	volatile u32 DENALI_PI_180;
	volatile u32 DENALI_PI_181;
	volatile u32 DENALI_PI_182;
	volatile u32 DENALI_PI_183;
	volatile u32 DENALI_PI_184;
	volatile u32 DENALI_PI_185;
	volatile u32 DENALI_PI_186;
	volatile u32 DENALI_PI_187;
	volatile u32 DENALI_PI_188;
	volatile u32 DENALI_PI_189;
	volatile u32 DENALI_PI_190;
	volatile u32 DENALI_PI_191;
	volatile u32 DENALI_PI_192;
	volatile u32 DENALI_PI_193;
	volatile u32 DENALI_PI_194;
	volatile u32 DENALI_PI_195;
	volatile u32 DENALI_PI_196;
	volatile u32 DENALI_PI_197;
	volatile u32 DENALI_PI_198;
	volatile u32 DENALI_PI_199;
	volatile u32 DENALI_PI_200;
	volatile u32 DENALI_PI_201;
	volatile u32 DENALI_PI_202;
	volatile u32 DENALI_PI_203;
	volatile u32 DENALI_PI_204;
	volatile u32 DENALI_PI_205;
	volatile u32 DENALI_PI_206;
	volatile u32 DENALI_PI_207;
	volatile u32 DENALI_PI_208;
	volatile u32 DENALI_PI_209;
	volatile u32 DENALI_PI_210;
	volatile u32 DENALI_PI_211;
	volatile u32 DENALI_PI_212;
	volatile u32 DENALI_PI_213;
	volatile u32 DENALI_PI_214;
	volatile u32 DENALI_PI_215;
	volatile u32 DENALI_PI_216;
	volatile u32 DENALI_PI_217;
	volatile u32 DENALI_PI_218;
	volatile u32 DENALI_PI_219;
	volatile u32 DENALI_PI_220;
	volatile u32 DENALI_PI_221;
	volatile u32 DENALI_PI_222;
	volatile u32 DENALI_PI_223;
	volatile u32 DENALI_PI_224;
	volatile u32 DENALI_PI_225;
	volatile u32 DENALI_PI_226;
	volatile u32 DENALI_PI_227;
	volatile u32 DENALI_PI_228;
	volatile u32 DENALI_PI_229;
	volatile u32 DENALI_PI_230;
	volatile u32 DENALI_PI_231;
	volatile u32 DENALI_PI_232;
	volatile u32 DENALI_PI_233;
	volatile u32 DENALI_PI_234;
	volatile u32 DENALI_PI_235;
	volatile u32 DENALI_PI_236;
	volatile u32 DENALI_PI_237;
	volatile u32 DENALI_PI_238;
	volatile u32 DENALI_PI_239;
	volatile u32 DENALI_PI_240;
	volatile u32 DENALI_PI_241;
	volatile u32 DENALI_PI_242;
	volatile u32 DENALI_PI_243;
	volatile u32 DENALI_PI_244;
	volatile u32 DENALI_PI_245;
	volatile u32 DENALI_PI_246;
	volatile u32 DENALI_PI_247;
	volatile u32 DENALI_PI_248;
	volatile u32 DENALI_PI_249;
	volatile u32 DENALI_PI_250;
	volatile u32 DENALI_PI_251;
	volatile u32 DENALI_PI_252;
	volatile u32 DENALI_PI_253;
	volatile u32 DENALI_PI_254;
	volatile u32 DENALI_PI_255;
	volatile u32 DENALI_PI_256;
	volatile u32 DENALI_PI_257;
	volatile u32 DENALI_PI_258;
	volatile u32 DENALI_PI_259;
	volatile u32 DENALI_PI_260;
	volatile u32 DENALI_PI_261;
	volatile u32 DENALI_PI_262;
	volatile u32 DENALI_PI_263;
	volatile u32 DENALI_PI_264;
	volatile u32 DENALI_PI_265;
	volatile u32 DENALI_PI_266;
	volatile u32 DENALI_PI_267;
	volatile u32 DENALI_PI_268;
	volatile u32 DENALI_PI_269;
	volatile u32 DENALI_PI_270;
	volatile u32 DENALI_PI_271;
	volatile u32 DENALI_PI_272;
	volatile u32 DENALI_PI_273;
	volatile u32 DENALI_PI_274;
	volatile u32 DENALI_PI_275;
	volatile u32 DENALI_PI_276;
	volatile u32 DENALI_PI_277;
	volatile u32 DENALI_PI_278;
	volatile u32 DENALI_PI_279;
	volatile u32 DENALI_PI_280;
	volatile u32 DENALI_PI_281;
	volatile u32 DENALI_PI_282;
	volatile u32 DENALI_PI_283;
	volatile u32 DENALI_PI_284;
	volatile u32 DENALI_PI_285;
	volatile u32 DENALI_PI_286;
	volatile u32 DENALI_PI_287;
	volatile u32 DENALI_PI_288;
	volatile u32 DENALI_PI_289;
	volatile u32 DENALI_PI_290;
	volatile u32 DENALI_PI_291;
	volatile u32 DENALI_PI_292;
	volatile u32 DENALI_PI_293;
	volatile u32 DENALI_PI_294;
	volatile u32 DENALI_PI_295;
	volatile u32 DENALI_PI_296;
	volatile u32 DENALI_PI_297;
	volatile u32 DENALI_PI_298;
	volatile u32 DENALI_PI_299;
	volatile u32 DENALI_PI_300;
	volatile u32 DENALI_PI_301;
	volatile u32 DENALI_PI_302;
	volatile u32 DENALI_PI_303;
	volatile u32 DENALI_PI_304;
	volatile u32 DENALI_PI_305;
	volatile u32 DENALI_PI_306;
	volatile u32 DENALI_PI_307;
	volatile u32 DENALI_PI_308;
	volatile u32 DENALI_PI_309;
	volatile u32 DENALI_PI_310;
	volatile u32 DENALI_PI_311;
	volatile u32 DENALI_PI_312;
	volatile u32 DENALI_PI_313;
	volatile u32 DENALI_PI_314;
	volatile u32 DENALI_PI_315;
	volatile u32 DENALI_PI_316;
	volatile u32 DENALI_PI_317;
	volatile u32 DENALI_PI_318;
	volatile u32 DENALI_PI_319;
	volatile u32 DENALI_PI_320;
	volatile u32 DENALI_PI_321;
	volatile u32 DENALI_PI_322;
	volatile u32 DENALI_PI_323;
	volatile u32 DENALI_PI_324;
	volatile u32 DENALI_PI_325;
	volatile u32 DENALI_PI_326;
	volatile u32 DENALI_PI_327;
	volatile u32 DENALI_PI_328;
	volatile u32 DENALI_PI_329;
	volatile u32 DENALI_PI_330;
	volatile u32 DENALI_PI_331;
	volatile u32 DENALI_PI_332;
	volatile u32 DENALI_PI_333;
	volatile u32 DENALI_PI_334;
	volatile u32 DENALI_PI_335;
	volatile u32 DENALI_PI_336;
	volatile u32 DENALI_PI_337;
	volatile u32 DENALI_PI_338;
	volatile u32 DENALI_PI_339;
	volatile u32 DENALI_PI_340;
	volatile u32 DENALI_PI_341;
	volatile u32 DENALI_PI_342;
	volatile u32 DENALI_PI_343;
	volatile u32 DENALI_PI_344;
	volatile u32 DENALI_PI_345;
	volatile u32 DENALI_PI_346;
	volatile u32 DENALI_PI_347;
	volatile u32 DENALI_PI_348;
	volatile u32 DENALI_PI_349;
	volatile u32 DENALI_PI_350;
	volatile u32 DENALI_PI_351;
	volatile u32 DENALI_PI_352;
	volatile u32 DENALI_PI_353;
	volatile u32 DENALI_PI_354;
	volatile u32 DENALI_PI_355;
	volatile u32 DENALI_PI_356;
	volatile u32 DENALI_PI_357;
	volatile u32 DENALI_PI_358;
	volatile u32 DENALI_PI_359;
	volatile u32 DENALI_PI_360;
	volatile u32 DENALI_PI_361;
	volatile u32 DENALI_PI_362;
	volatile u32 DENALI_PI_363;
	volatile u32 DENALI_PI_364;
	volatile u32 DENALI_PI_365;
	volatile u32 DENALI_PI_366;
	volatile u32 DENALI_PI_367;
	volatile u32 DENALI_PI_368;
	volatile u32 DENALI_PI_369;
	volatile u32 DENALI_PI_370;
	volatile u32 DENALI_PI_371;
	volatile u32 DENALI_PI_372;
	volatile u32 DENALI_PI_373;
	volatile u32 DENALI_PI_374;
	volatile u32 DENALI_PI_375;
	volatile u32 DENALI_PI_376;
	volatile u32 DENALI_PI_377;
	volatile u32 DENALI_PI_378;
	volatile u32 DENALI_PI_379;
	volatile u32 DENALI_PI_380;
	volatile u32 DENALI_PI_381;
	volatile u32 DENALI_PI_382;
	volatile u32 DENALI_PI_383;
	volatile u32 DENALI_PI_384;
	volatile u32 DENALI_PI_385;
	volatile u32 DENALI_PI_386;
	volatile u32 DENALI_PI_387;
	volatile u32 DENALI_PI_388;
	volatile u32 DENALI_PI_389;
	volatile u32 DENALI_PI_390;
	volatile u32 DENALI_PI_391;
	volatile u32 DENALI_PI_392;
	volatile u32 DENALI_PI_393;
	volatile u32 DENALI_PI_394;
	volatile u32 DENALI_PI_395;
	volatile u32 DENALI_PI_396;
	volatile u32 DENALI_PI_397;
	volatile u32 DENALI_PI_398;
	volatile u32 DENALI_PI_399;
	volatile u32 DENALI_PI_400;
	volatile u32 DENALI_PI_401;
	volatile u32 DENALI_PI_402;
	volatile u32 DENALI_PI_403;
	volatile u32 DENALI_PI_404;
	volatile u32 DENALI_PI_405;
	volatile u32 DENALI_PI_406;
	volatile u32 DENALI_PI_407;
	volatile u32 DENALI_PI_408;
	volatile u32 DENALI_PI_409;
	volatile u32 DENALI_PI_410;
	volatile u32 DENALI_PI_411;
	volatile u32 DENALI_PI_412;
	volatile u32 DENALI_PI_413;
	volatile u32 DENALI_PI_414;
	volatile u32 DENALI_PI_415;
	volatile u32 DENALI_PI_416;
	volatile u32 DENALI_PI_417;
	volatile u32 DENALI_PI_418;
	volatile u32 DENALI_PI_419;
	volatile u32 DENALI_PI_420;
	volatile u32 DENALI_PI_421;
	volatile u32 DENALI_PI_422;
	volatile u32 DENALI_PI_423;
	volatile char pad__1[0x1960U];
	volatile u32 DENALI_PHY_0;
	volatile u32 DENALI_PHY_1;
	volatile u32 DENALI_PHY_2;
	volatile u32 DENALI_PHY_3;
	volatile u32 DENALI_PHY_4;
	volatile u32 DENALI_PHY_5;
	volatile u32 DENALI_PHY_6;
	volatile u32 DENALI_PHY_7;
	volatile u32 DENALI_PHY_8;
	volatile u32 DENALI_PHY_9;
	volatile u32 DENALI_PHY_10;
	volatile u32 DENALI_PHY_11;
	volatile u32 DENALI_PHY_12;
	volatile u32 DENALI_PHY_13;
	volatile u32 DENALI_PHY_14;
	volatile u32 DENALI_PHY_15;
	volatile u32 DENALI_PHY_16;
	volatile u32 DENALI_PHY_17;
	volatile u32 DENALI_PHY_18;
	volatile u32 DENALI_PHY_19;
	volatile u32 DENALI_PHY_20;
	volatile u32 DENALI_PHY_21;
	volatile u32 DENALI_PHY_22;
	volatile u32 DENALI_PHY_23;
	volatile u32 DENALI_PHY_24;
	volatile u32 DENALI_PHY_25;
	volatile u32 DENALI_PHY_26;
	volatile u32 DENALI_PHY_27;
	volatile u32 DENALI_PHY_28;
	volatile u32 DENALI_PHY_29;
	volatile u32 DENALI_PHY_30;
	volatile u32 DENALI_PHY_31;
	volatile u32 DENALI_PHY_32;
	volatile u32 DENALI_PHY_33;
	volatile u32 DENALI_PHY_34;
	volatile u32 DENALI_PHY_35;
	volatile u32 DENALI_PHY_36;
	volatile u32 DENALI_PHY_37;
	volatile u32 DENALI_PHY_38;
	volatile u32 DENALI_PHY_39;
	volatile u32 DENALI_PHY_40;
	volatile u32 DENALI_PHY_41;
	volatile u32 DENALI_PHY_42;
	volatile u32 DENALI_PHY_43;
	volatile u32 DENALI_PHY_44;
	volatile u32 DENALI_PHY_45;
	volatile u32 DENALI_PHY_46;
	volatile u32 DENALI_PHY_47;
	volatile u32 DENALI_PHY_48;
	volatile u32 DENALI_PHY_49;
	volatile u32 DENALI_PHY_50;
	volatile u32 DENALI_PHY_51;
	volatile u32 DENALI_PHY_52;
	volatile u32 DENALI_PHY_53;
	volatile u32 DENALI_PHY_54;
	volatile u32 DENALI_PHY_55;
	volatile u32 DENALI_PHY_56;
	volatile u32 DENALI_PHY_57;
	volatile u32 DENALI_PHY_58;
	volatile u32 DENALI_PHY_59;
	volatile u32 DENALI_PHY_60;
	volatile u32 DENALI_PHY_61;
	volatile u32 DENALI_PHY_62;
	volatile u32 DENALI_PHY_63;
	volatile u32 DENALI_PHY_64;
	volatile u32 DENALI_PHY_65;
	volatile u32 DENALI_PHY_66;
	volatile u32 DENALI_PHY_67;
	volatile u32 DENALI_PHY_68;
	volatile u32 DENALI_PHY_69;
	volatile u32 DENALI_PHY_70;
	volatile u32 DENALI_PHY_71;
	volatile u32 DENALI_PHY_72;
	volatile u32 DENALI_PHY_73;
	volatile u32 DENALI_PHY_74;
	volatile u32 DENALI_PHY_75;
	volatile u32 DENALI_PHY_76;
	volatile u32 DENALI_PHY_77;
	volatile u32 DENALI_PHY_78;
	volatile u32 DENALI_PHY_79;
	volatile u32 DENALI_PHY_80;
	volatile u32 DENALI_PHY_81;
	volatile u32 DENALI_PHY_82;
	volatile u32 DENALI_PHY_83;
	volatile u32 DENALI_PHY_84;
	volatile u32 DENALI_PHY_85;
	volatile u32 DENALI_PHY_86;
	volatile u32 DENALI_PHY_87;
	volatile u32 DENALI_PHY_88;
	volatile u32 DENALI_PHY_89;
	volatile u32 DENALI_PHY_90;
	volatile u32 DENALI_PHY_91;
	volatile u32 DENALI_PHY_92;
	volatile u32 DENALI_PHY_93;
	volatile u32 DENALI_PHY_94;
	volatile u32 DENALI_PHY_95;
	volatile u32 DENALI_PHY_96;
	volatile u32 DENALI_PHY_97;
	volatile u32 DENALI_PHY_98;
	volatile u32 DENALI_PHY_99;
	volatile u32 DENALI_PHY_100;
	volatile u32 DENALI_PHY_101;
	volatile u32 DENALI_PHY_102;
	volatile u32 DENALI_PHY_103;
	volatile u32 DENALI_PHY_104;
	volatile u32 DENALI_PHY_105;
	volatile u32 DENALI_PHY_106;
	volatile u32 DENALI_PHY_107;
	volatile u32 DENALI_PHY_108;
	volatile u32 DENALI_PHY_109;
	volatile u32 DENALI_PHY_110;
	volatile u32 DENALI_PHY_111;
	volatile u32 DENALI_PHY_112;
	volatile u32 DENALI_PHY_113;
	volatile u32 DENALI_PHY_114;
	volatile u32 DENALI_PHY_115;
	volatile u32 DENALI_PHY_116;
	volatile u32 DENALI_PHY_117;
	volatile u32 DENALI_PHY_118;
	volatile u32 DENALI_PHY_119;
	volatile u32 DENALI_PHY_120;
	volatile u32 DENALI_PHY_121;
	volatile u32 DENALI_PHY_122;
	volatile u32 DENALI_PHY_123;
	volatile u32 DENALI_PHY_124;
	volatile u32 DENALI_PHY_125;
	volatile u32 DENALI_PHY_126;
	volatile u32 DENALI_PHY_127;
	volatile u32 DENALI_PHY_128;
	volatile u32 DENALI_PHY_129;
	volatile u32 DENALI_PHY_130;
	volatile u32 DENALI_PHY_131;
	volatile u32 DENALI_PHY_132;
	volatile u32 DENALI_PHY_133;
	volatile u32 DENALI_PHY_134;
	volatile u32 DENALI_PHY_135;
	volatile u32 DENALI_PHY_136;
	volatile char pad__2[0x1DCU];
	volatile u32 DENALI_PHY_256;
	volatile u32 DENALI_PHY_257;
	volatile u32 DENALI_PHY_258;
	volatile u32 DENALI_PHY_259;
	volatile u32 DENALI_PHY_260;
	volatile u32 DENALI_PHY_261;
	volatile u32 DENALI_PHY_262;
	volatile u32 DENALI_PHY_263;
	volatile u32 DENALI_PHY_264;
	volatile u32 DENALI_PHY_265;
	volatile u32 DENALI_PHY_266;
	volatile u32 DENALI_PHY_267;
	volatile u32 DENALI_PHY_268;
	volatile u32 DENALI_PHY_269;
	volatile u32 DENALI_PHY_270;
	volatile u32 DENALI_PHY_271;
	volatile u32 DENALI_PHY_272;
	volatile u32 DENALI_PHY_273;
	volatile u32 DENALI_PHY_274;
	volatile u32 DENALI_PHY_275;
	volatile u32 DENALI_PHY_276;
	volatile u32 DENALI_PHY_277;
	volatile u32 DENALI_PHY_278;
	volatile u32 DENALI_PHY_279;
	volatile u32 DENALI_PHY_280;
	volatile u32 DENALI_PHY_281;
	volatile u32 DENALI_PHY_282;
	volatile u32 DENALI_PHY_283;
	volatile u32 DENALI_PHY_284;
	volatile u32 DENALI_PHY_285;
	volatile u32 DENALI_PHY_286;
	volatile u32 DENALI_PHY_287;
	volatile u32 DENALI_PHY_288;
	volatile u32 DENALI_PHY_289;
	volatile u32 DENALI_PHY_290;
	volatile u32 DENALI_PHY_291;
	volatile u32 DENALI_PHY_292;
	volatile u32 DENALI_PHY_293;
	volatile u32 DENALI_PHY_294;
	volatile u32 DENALI_PHY_295;
	volatile u32 DENALI_PHY_296;
	volatile u32 DENALI_PHY_297;
	volatile u32 DENALI_PHY_298;
	volatile u32 DENALI_PHY_299;
	volatile u32 DENALI_PHY_300;
	volatile u32 DENALI_PHY_301;
	volatile u32 DENALI_PHY_302;
	volatile u32 DENALI_PHY_303;
	volatile u32 DENALI_PHY_304;
	volatile u32 DENALI_PHY_305;
	volatile u32 DENALI_PHY_306;
	volatile u32 DENALI_PHY_307;
	volatile u32 DENALI_PHY_308;
	volatile u32 DENALI_PHY_309;
	volatile u32 DENALI_PHY_310;
	volatile u32 DENALI_PHY_311;
	volatile u32 DENALI_PHY_312;
	volatile u32 DENALI_PHY_313;
	volatile u32 DENALI_PHY_314;
	volatile u32 DENALI_PHY_315;
	volatile u32 DENALI_PHY_316;
	volatile u32 DENALI_PHY_317;
	volatile u32 DENALI_PHY_318;
	volatile u32 DENALI_PHY_319;
	volatile u32 DENALI_PHY_320;
	volatile u32 DENALI_PHY_321;
	volatile u32 DENALI_PHY_322;
	volatile u32 DENALI_PHY_323;
	volatile u32 DENALI_PHY_324;
	volatile u32 DENALI_PHY_325;
	volatile u32 DENALI_PHY_326;
	volatile u32 DENALI_PHY_327;
	volatile u32 DENALI_PHY_328;
	volatile u32 DENALI_PHY_329;
	volatile u32 DENALI_PHY_330;
	volatile u32 DENALI_PHY_331;
	volatile u32 DENALI_PHY_332;
	volatile u32 DENALI_PHY_333;
	volatile u32 DENALI_PHY_334;
	volatile u32 DENALI_PHY_335;
	volatile u32 DENALI_PHY_336;
	volatile u32 DENALI_PHY_337;
	volatile u32 DENALI_PHY_338;
	volatile u32 DENALI_PHY_339;
	volatile u32 DENALI_PHY_340;
	volatile u32 DENALI_PHY_341;
	volatile u32 DENALI_PHY_342;
	volatile u32 DENALI_PHY_343;
	volatile u32 DENALI_PHY_344;
	volatile u32 DENALI_PHY_345;
	volatile u32 DENALI_PHY_346;
	volatile u32 DENALI_PHY_347;
	volatile u32 DENALI_PHY_348;
	volatile u32 DENALI_PHY_349;
	volatile u32 DENALI_PHY_350;
	volatile u32 DENALI_PHY_351;
	volatile u32 DENALI_PHY_352;
	volatile u32 DENALI_PHY_353;
	volatile u32 DENALI_PHY_354;
	volatile u32 DENALI_PHY_355;
	volatile u32 DENALI_PHY_356;
	volatile u32 DENALI_PHY_357;
	volatile u32 DENALI_PHY_358;
	volatile u32 DENALI_PHY_359;
	volatile u32 DENALI_PHY_360;
	volatile u32 DENALI_PHY_361;
	volatile u32 DENALI_PHY_362;
	volatile u32 DENALI_PHY_363;
	volatile u32 DENALI_PHY_364;
	volatile u32 DENALI_PHY_365;
	volatile u32 DENALI_PHY_366;
	volatile u32 DENALI_PHY_367;
	volatile u32 DENALI_PHY_368;
	volatile u32 DENALI_PHY_369;
	volatile u32 DENALI_PHY_370;
	volatile u32 DENALI_PHY_371;
	volatile u32 DENALI_PHY_372;
	volatile u32 DENALI_PHY_373;
	volatile u32 DENALI_PHY_374;
	volatile u32 DENALI_PHY_375;
	volatile u32 DENALI_PHY_376;
	volatile u32 DENALI_PHY_377;
	volatile u32 DENALI_PHY_378;
	volatile u32 DENALI_PHY_379;
	volatile u32 DENALI_PHY_380;
	volatile u32 DENALI_PHY_381;
	volatile u32 DENALI_PHY_382;
	volatile u32 DENALI_PHY_383;
	volatile u32 DENALI_PHY_384;
	volatile u32 DENALI_PHY_385;
	volatile u32 DENALI_PHY_386;
	volatile u32 DENALI_PHY_387;
	volatile u32 DENALI_PHY_388;
	volatile u32 DENALI_PHY_389;
	volatile u32 DENALI_PHY_390;
	volatile u32 DENALI_PHY_391;
	volatile u32 DENALI_PHY_392;
	volatile char pad__3[0x1DCU];
	volatile u32 DENALI_PHY_512;
	volatile u32 DENALI_PHY_513;
	volatile u32 DENALI_PHY_514;
	volatile u32 DENALI_PHY_515;
	volatile u32 DENALI_PHY_516;
	volatile u32 DENALI_PHY_517;
	volatile u32 DENALI_PHY_518;
	volatile u32 DENALI_PHY_519;
	volatile u32 DENALI_PHY_520;
	volatile u32 DENALI_PHY_521;
	volatile u32 DENALI_PHY_522;
	volatile u32 DENALI_PHY_523;
	volatile u32 DENALI_PHY_524;
	volatile u32 DENALI_PHY_525;
	volatile u32 DENALI_PHY_526;
	volatile u32 DENALI_PHY_527;
	volatile u32 DENALI_PHY_528;
	volatile u32 DENALI_PHY_529;
	volatile u32 DENALI_PHY_530;
	volatile u32 DENALI_PHY_531;
	volatile u32 DENALI_PHY_532;
	volatile u32 DENALI_PHY_533;
	volatile u32 DENALI_PHY_534;
	volatile u32 DENALI_PHY_535;
	volatile u32 DENALI_PHY_536;
	volatile u32 DENALI_PHY_537;
	volatile u32 DENALI_PHY_538;
	volatile u32 DENALI_PHY_539;
	volatile u32 DENALI_PHY_540;
	volatile u32 DENALI_PHY_541;
	volatile u32 DENALI_PHY_542;
	volatile u32 DENALI_PHY_543;
	volatile u32 DENALI_PHY_544;
	volatile u32 DENALI_PHY_545;
	volatile u32 DENALI_PHY_546;
	volatile u32 DENALI_PHY_547;
	volatile u32 DENALI_PHY_548;
	volatile u32 DENALI_PHY_549;
	volatile u32 DENALI_PHY_550;
	volatile u32 DENALI_PHY_551;
	volatile u32 DENALI_PHY_552;
	volatile u32 DENALI_PHY_553;
	volatile u32 DENALI_PHY_554;
	volatile u32 DENALI_PHY_555;
	volatile u32 DENALI_PHY_556;
	volatile u32 DENALI_PHY_557;
	volatile u32 DENALI_PHY_558;
	volatile u32 DENALI_PHY_559;
	volatile u32 DENALI_PHY_560;
	volatile u32 DENALI_PHY_561;
	volatile u32 DENALI_PHY_562;
	volatile u32 DENALI_PHY_563;
	volatile u32 DENALI_PHY_564;
	volatile u32 DENALI_PHY_565;
	volatile u32 DENALI_PHY_566;
	volatile u32 DENALI_PHY_567;
	volatile u32 DENALI_PHY_568;
	volatile u32 DENALI_PHY_569;
	volatile u32 DENALI_PHY_570;
	volatile u32 DENALI_PHY_571;
	volatile u32 DENALI_PHY_572;
	volatile u32 DENALI_PHY_573;
	volatile u32 DENALI_PHY_574;
	volatile u32 DENALI_PHY_575;
	volatile u32 DENALI_PHY_576;
	volatile u32 DENALI_PHY_577;
	volatile u32 DENALI_PHY_578;
	volatile u32 DENALI_PHY_579;
	volatile u32 DENALI_PHY_580;
	volatile u32 DENALI_PHY_581;
	volatile u32 DENALI_PHY_582;
	volatile u32 DENALI_PHY_583;
	volatile u32 DENALI_PHY_584;
	volatile u32 DENALI_PHY_585;
	volatile u32 DENALI_PHY_586;
	volatile u32 DENALI_PHY_587;
	volatile u32 DENALI_PHY_588;
	volatile u32 DENALI_PHY_589;
	volatile u32 DENALI_PHY_590;
	volatile u32 DENALI_PHY_591;
	volatile u32 DENALI_PHY_592;
	volatile u32 DENALI_PHY_593;
	volatile u32 DENALI_PHY_594;
	volatile u32 DENALI_PHY_595;
	volatile u32 DENALI_PHY_596;
	volatile u32 DENALI_PHY_597;
	volatile u32 DENALI_PHY_598;
	volatile u32 DENALI_PHY_599;
	volatile u32 DENALI_PHY_600;
	volatile u32 DENALI_PHY_601;
	volatile u32 DENALI_PHY_602;
	volatile u32 DENALI_PHY_603;
	volatile u32 DENALI_PHY_604;
	volatile u32 DENALI_PHY_605;
	volatile u32 DENALI_PHY_606;
	volatile u32 DENALI_PHY_607;
	volatile u32 DENALI_PHY_608;
	volatile u32 DENALI_PHY_609;
	volatile u32 DENALI_PHY_610;
	volatile u32 DENALI_PHY_611;
	volatile u32 DENALI_PHY_612;
	volatile u32 DENALI_PHY_613;
	volatile u32 DENALI_PHY_614;
	volatile u32 DENALI_PHY_615;
	volatile u32 DENALI_PHY_616;
	volatile u32 DENALI_PHY_617;
	volatile u32 DENALI_PHY_618;
	volatile u32 DENALI_PHY_619;
	volatile u32 DENALI_PHY_620;
	volatile u32 DENALI_PHY_621;
	volatile u32 DENALI_PHY_622;
	volatile u32 DENALI_PHY_623;
	volatile u32 DENALI_PHY_624;
	volatile u32 DENALI_PHY_625;
	volatile u32 DENALI_PHY_626;
	volatile u32 DENALI_PHY_627;
	volatile u32 DENALI_PHY_628;
	volatile u32 DENALI_PHY_629;
	volatile u32 DENALI_PHY_630;
	volatile u32 DENALI_PHY_631;
	volatile u32 DENALI_PHY_632;
	volatile u32 DENALI_PHY_633;
	volatile u32 DENALI_PHY_634;
	volatile u32 DENALI_PHY_635;
	volatile u32 DENALI_PHY_636;
	volatile u32 DENALI_PHY_637;
	volatile u32 DENALI_PHY_638;
	volatile u32 DENALI_PHY_639;
	volatile u32 DENALI_PHY_640;
	volatile u32 DENALI_PHY_641;
	volatile u32 DENALI_PHY_642;
	volatile u32 DENALI_PHY_643;
	volatile u32 DENALI_PHY_644;
	volatile u32 DENALI_PHY_645;
	volatile u32 DENALI_PHY_646;
	volatile u32 DENALI_PHY_647;
	volatile u32 DENALI_PHY_648;
	volatile char pad__4[0x1DCU];
	volatile u32 DENALI_PHY_768;
	volatile u32 DENALI_PHY_769;
	volatile u32 DENALI_PHY_770;
	volatile u32 DENALI_PHY_771;
	volatile u32 DENALI_PHY_772;
	volatile u32 DENALI_PHY_773;
	volatile u32 DENALI_PHY_774;
	volatile u32 DENALI_PHY_775;
	volatile u32 DENALI_PHY_776;
	volatile u32 DENALI_PHY_777;
	volatile u32 DENALI_PHY_778;
	volatile u32 DENALI_PHY_779;
	volatile u32 DENALI_PHY_780;
	volatile u32 DENALI_PHY_781;
	volatile u32 DENALI_PHY_782;
	volatile u32 DENALI_PHY_783;
	volatile u32 DENALI_PHY_784;
	volatile u32 DENALI_PHY_785;
	volatile u32 DENALI_PHY_786;
	volatile u32 DENALI_PHY_787;
	volatile u32 DENALI_PHY_788;
	volatile u32 DENALI_PHY_789;
	volatile u32 DENALI_PHY_790;
	volatile u32 DENALI_PHY_791;
	volatile u32 DENALI_PHY_792;
	volatile u32 DENALI_PHY_793;
	volatile u32 DENALI_PHY_794;
	volatile u32 DENALI_PHY_795;
	volatile u32 DENALI_PHY_796;
	volatile u32 DENALI_PHY_797;
	volatile u32 DENALI_PHY_798;
	volatile u32 DENALI_PHY_799;
	volatile u32 DENALI_PHY_800;
	volatile u32 DENALI_PHY_801;
	volatile u32 DENALI_PHY_802;
	volatile u32 DENALI_PHY_803;
	volatile u32 DENALI_PHY_804;
	volatile u32 DENALI_PHY_805;
	volatile u32 DENALI_PHY_806;
	volatile u32 DENALI_PHY_807;
	volatile u32 DENALI_PHY_808;
	volatile u32 DENALI_PHY_809;
	volatile u32 DENALI_PHY_810;
	volatile u32 DENALI_PHY_811;
	volatile u32 DENALI_PHY_812;
	volatile u32 DENALI_PHY_813;
	volatile u32 DENALI_PHY_814;
	volatile u32 DENALI_PHY_815;
	volatile u32 DENALI_PHY_816;
	volatile u32 DENALI_PHY_817;
	volatile u32 DENALI_PHY_818;
	volatile u32 DENALI_PHY_819;
	volatile u32 DENALI_PHY_820;
	volatile u32 DENALI_PHY_821;
	volatile u32 DENALI_PHY_822;
	volatile u32 DENALI_PHY_823;
	volatile u32 DENALI_PHY_824;
	volatile u32 DENALI_PHY_825;
	volatile u32 DENALI_PHY_826;
	volatile u32 DENALI_PHY_827;
	volatile u32 DENALI_PHY_828;
	volatile u32 DENALI_PHY_829;
	volatile u32 DENALI_PHY_830;
	volatile u32 DENALI_PHY_831;
	volatile u32 DENALI_PHY_832;
	volatile u32 DENALI_PHY_833;
	volatile u32 DENALI_PHY_834;
	volatile u32 DENALI_PHY_835;
	volatile u32 DENALI_PHY_836;
	volatile u32 DENALI_PHY_837;
	volatile u32 DENALI_PHY_838;
	volatile u32 DENALI_PHY_839;
	volatile u32 DENALI_PHY_840;
	volatile u32 DENALI_PHY_841;
	volatile u32 DENALI_PHY_842;
	volatile u32 DENALI_PHY_843;
	volatile u32 DENALI_PHY_844;
	volatile u32 DENALI_PHY_845;
	volatile u32 DENALI_PHY_846;
	volatile u32 DENALI_PHY_847;
	volatile u32 DENALI_PHY_848;
	volatile u32 DENALI_PHY_849;
	volatile u32 DENALI_PHY_850;
	volatile u32 DENALI_PHY_851;
	volatile u32 DENALI_PHY_852;
	volatile u32 DENALI_PHY_853;
	volatile u32 DENALI_PHY_854;
	volatile u32 DENALI_PHY_855;
	volatile u32 DENALI_PHY_856;
	volatile u32 DENALI_PHY_857;
	volatile u32 DENALI_PHY_858;
	volatile u32 DENALI_PHY_859;
	volatile u32 DENALI_PHY_860;
	volatile u32 DENALI_PHY_861;
	volatile u32 DENALI_PHY_862;
	volatile u32 DENALI_PHY_863;
	volatile u32 DENALI_PHY_864;
	volatile u32 DENALI_PHY_865;
	volatile u32 DENALI_PHY_866;
	volatile u32 DENALI_PHY_867;
	volatile u32 DENALI_PHY_868;
	volatile u32 DENALI_PHY_869;
	volatile u32 DENALI_PHY_870;
	volatile u32 DENALI_PHY_871;
	volatile u32 DENALI_PHY_872;
	volatile u32 DENALI_PHY_873;
	volatile u32 DENALI_PHY_874;
	volatile u32 DENALI_PHY_875;
	volatile u32 DENALI_PHY_876;
	volatile u32 DENALI_PHY_877;
	volatile u32 DENALI_PHY_878;
	volatile u32 DENALI_PHY_879;
	volatile u32 DENALI_PHY_880;
	volatile u32 DENALI_PHY_881;
	volatile u32 DENALI_PHY_882;
	volatile u32 DENALI_PHY_883;
	volatile u32 DENALI_PHY_884;
	volatile u32 DENALI_PHY_885;
	volatile u32 DENALI_PHY_886;
	volatile u32 DENALI_PHY_887;
	volatile u32 DENALI_PHY_888;
	volatile u32 DENALI_PHY_889;
	volatile u32 DENALI_PHY_890;
	volatile u32 DENALI_PHY_891;
	volatile u32 DENALI_PHY_892;
	volatile u32 DENALI_PHY_893;
	volatile u32 DENALI_PHY_894;
	volatile u32 DENALI_PHY_895;
	volatile u32 DENALI_PHY_896;
	volatile u32 DENALI_PHY_897;
	volatile u32 DENALI_PHY_898;
	volatile u32 DENALI_PHY_899;
	volatile u32 DENALI_PHY_900;
	volatile u32 DENALI_PHY_901;
	volatile u32 DENALI_PHY_902;
	volatile u32 DENALI_PHY_903;
	volatile u32 DENALI_PHY_904;
	volatile char pad__5[0x1DCU];
	volatile u32 DENALI_PHY_1024;
	volatile u32 DENALI_PHY_1025;
	volatile u32 DENALI_PHY_1026;
	volatile u32 DENALI_PHY_1027;
	volatile u32 DENALI_PHY_1028;
	volatile u32 DENALI_PHY_1029;
	volatile u32 DENALI_PHY_1030;
	volatile u32 DENALI_PHY_1031;
	volatile u32 DENALI_PHY_1032;
	volatile u32 DENALI_PHY_1033;
	volatile u32 DENALI_PHY_1034;
	volatile u32 DENALI_PHY_1035;
	volatile u32 DENALI_PHY_1036;
	volatile u32 DENALI_PHY_1037;
	volatile u32 DENALI_PHY_1038;
	volatile u32 DENALI_PHY_1039;
	volatile u32 DENALI_PHY_1040;
	volatile u32 DENALI_PHY_1041;
	volatile u32 DENALI_PHY_1042;
	volatile u32 DENALI_PHY_1043;
	volatile u32 DENALI_PHY_1044;
	volatile u32 DENALI_PHY_1045;
	volatile u32 DENALI_PHY_1046;
	volatile u32 DENALI_PHY_1047;
	volatile u32 DENALI_PHY_1048;
	volatile u32 DENALI_PHY_1049;
	volatile u32 DENALI_PHY_1050;
	volatile u32 DENALI_PHY_1051;
	volatile u32 DENALI_PHY_1052;
	volatile u32 DENALI_PHY_1053;
	volatile u32 DENALI_PHY_1054;
	volatile u32 DENALI_PHY_1055;
	volatile u32 DENALI_PHY_1056;
	volatile u32 DENALI_PHY_1057;
	volatile u32 DENALI_PHY_1058;
	volatile u32 DENALI_PHY_1059;
	volatile u32 DENALI_PHY_1060;
	volatile u32 DENALI_PHY_1061;
	volatile u32 DENALI_PHY_1062;
	volatile u32 DENALI_PHY_1063;
	volatile u32 DENALI_PHY_1064;
	volatile u32 DENALI_PHY_1065;
	volatile u32 DENALI_PHY_1066;
	volatile u32 DENALI_PHY_1067;
	volatile u32 DENALI_PHY_1068;
	volatile u32 DENALI_PHY_1069;
	volatile u32 DENALI_PHY_1070;
	volatile u32 DENALI_PHY_1071;
	volatile u32 DENALI_PHY_1072;
	volatile char pad__6[0x33CU];
	volatile u32 DENALI_PHY_1280;
	volatile u32 DENALI_PHY_1281;
	volatile u32 DENALI_PHY_1282;
	volatile u32 DENALI_PHY_1283;
	volatile u32 DENALI_PHY_1284;
	volatile u32 DENALI_PHY_1285;
	volatile u32 DENALI_PHY_1286;
	volatile u32 DENALI_PHY_1287;
	volatile u32 DENALI_PHY_1288;
	volatile u32 DENALI_PHY_1289;
	volatile u32 DENALI_PHY_1290;
	volatile u32 DENALI_PHY_1291;
	volatile u32 DENALI_PHY_1292;
	volatile u32 DENALI_PHY_1293;
	volatile u32 DENALI_PHY_1294;
	volatile u32 DENALI_PHY_1295;
	volatile u32 DENALI_PHY_1296;
	volatile u32 DENALI_PHY_1297;
	volatile u32 DENALI_PHY_1298;
	volatile u32 DENALI_PHY_1299;
	volatile u32 DENALI_PHY_1300;
	volatile u32 DENALI_PHY_1301;
	volatile u32 DENALI_PHY_1302;
	volatile u32 DENALI_PHY_1303;
	volatile u32 DENALI_PHY_1304;
	volatile u32 DENALI_PHY_1305;
	volatile u32 DENALI_PHY_1306;
	volatile u32 DENALI_PHY_1307;
	volatile u32 DENALI_PHY_1308;
	volatile u32 DENALI_PHY_1309;
	volatile u32 DENALI_PHY_1310;
	volatile u32 DENALI_PHY_1311;
	volatile u32 DENALI_PHY_1312;
	volatile u32 DENALI_PHY_1313;
	volatile u32 DENALI_PHY_1314;
	volatile u32 DENALI_PHY_1315;
	volatile u32 DENALI_PHY_1316;
	volatile u32 DENALI_PHY_1317;
	volatile u32 DENALI_PHY_1318;
	volatile u32 DENALI_PHY_1319;
	volatile u32 DENALI_PHY_1320;
	volatile u32 DENALI_PHY_1321;
	volatile u32 DENALI_PHY_1322;
	volatile u32 DENALI_PHY_1323;
	volatile u32 DENALI_PHY_1324;
	volatile u32 DENALI_PHY_1325;
	volatile u32 DENALI_PHY_1326;
	volatile u32 DENALI_PHY_1327;
	volatile u32 DENALI_PHY_1328;
	volatile char pad__7[0x33CU];
	volatile u32 DENALI_PHY_1536;
	volatile u32 DENALI_PHY_1537;
	volatile u32 DENALI_PHY_1538;
	volatile u32 DENALI_PHY_1539;
	volatile u32 DENALI_PHY_1540;
	volatile u32 DENALI_PHY_1541;
	volatile u32 DENALI_PHY_1542;
	volatile u32 DENALI_PHY_1543;
	volatile u32 DENALI_PHY_1544;
	volatile u32 DENALI_PHY_1545;
	volatile u32 DENALI_PHY_1546;
	volatile u32 DENALI_PHY_1547;
	volatile u32 DENALI_PHY_1548;
	volatile u32 DENALI_PHY_1549;
	volatile u32 DENALI_PHY_1550;
	volatile u32 DENALI_PHY_1551;
	volatile u32 DENALI_PHY_1552;
	volatile u32 DENALI_PHY_1553;
	volatile u32 DENALI_PHY_1554;
	volatile u32 DENALI_PHY_1555;
	volatile u32 DENALI_PHY_1556;
	volatile u32 DENALI_PHY_1557;
	volatile u32 DENALI_PHY_1558;
	volatile u32 DENALI_PHY_1559;
	volatile u32 DENALI_PHY_1560;
	volatile u32 DENALI_PHY_1561;
	volatile u32 DENALI_PHY_1562;
	volatile u32 DENALI_PHY_1563;
	volatile u32 DENALI_PHY_1564;
	volatile u32 DENALI_PHY_1565;
	volatile u32 DENALI_PHY_1566;
	volatile u32 DENALI_PHY_1567;
	volatile u32 DENALI_PHY_1568;
	volatile u32 DENALI_PHY_1569;
	volatile u32 DENALI_PHY_1570;
	volatile u32 DENALI_PHY_1571;
	volatile u32 DENALI_PHY_1572;
	volatile u32 DENALI_PHY_1573;
	volatile u32 DENALI_PHY_1574;
	volatile u32 DENALI_PHY_1575;
	volatile u32 DENALI_PHY_1576;
	volatile u32 DENALI_PHY_1577;
	volatile u32 DENALI_PHY_1578;
	volatile u32 DENALI_PHY_1579;
	volatile u32 DENALI_PHY_1580;
	volatile u32 DENALI_PHY_1581;
	volatile u32 DENALI_PHY_1582;
	volatile u32 DENALI_PHY_1583;
	volatile u32 DENALI_PHY_1584;
	volatile char pad__8[0x33CU];
	volatile u32 DENALI_PHY_1792;
	volatile u32 DENALI_PHY_1793;
	volatile u32 DENALI_PHY_1794;
	volatile u32 DENALI_PHY_1795;
	volatile u32 DENALI_PHY_1796;
	volatile u32 DENALI_PHY_1797;
	volatile u32 DENALI_PHY_1798;
	volatile u32 DENALI_PHY_1799;
	volatile u32 DENALI_PHY_1800;
	volatile u32 DENALI_PHY_1801;
	volatile u32 DENALI_PHY_1802;
	volatile u32 DENALI_PHY_1803;
	volatile u32 DENALI_PHY_1804;
	volatile u32 DENALI_PHY_1805;
	volatile u32 DENALI_PHY_1806;
	volatile u32 DENALI_PHY_1807;
	volatile u32 DENALI_PHY_1808;
	volatile u32 DENALI_PHY_1809;
	volatile u32 DENALI_PHY_1810;
	volatile u32 DENALI_PHY_1811;
	volatile u32 DENALI_PHY_1812;
	volatile u32 DENALI_PHY_1813;
	volatile u32 DENALI_PHY_1814;
	volatile u32 DENALI_PHY_1815;
	volatile u32 DENALI_PHY_1816;
	volatile u32 DENALI_PHY_1817;
	volatile u32 DENALI_PHY_1818;
	volatile u32 DENALI_PHY_1819;
	volatile u32 DENALI_PHY_1820;
	volatile u32 DENALI_PHY_1821;
	volatile u32 DENALI_PHY_1822;
	volatile u32 DENALI_PHY_1823;
	volatile u32 DENALI_PHY_1824;
	volatile u32 DENALI_PHY_1825;
	volatile u32 DENALI_PHY_1826;
	volatile u32 DENALI_PHY_1827;
	volatile u32 DENALI_PHY_1828;
	volatile u32 DENALI_PHY_1829;
	volatile u32 DENALI_PHY_1830;
	volatile u32 DENALI_PHY_1831;
	volatile u32 DENALI_PHY_1832;
	volatile u32 DENALI_PHY_1833;
	volatile u32 DENALI_PHY_1834;
	volatile u32 DENALI_PHY_1835;
	volatile u32 DENALI_PHY_1836;
	volatile u32 DENALI_PHY_1837;
	volatile u32 DENALI_PHY_1838;
	volatile u32 DENALI_PHY_1839;
	volatile u32 DENALI_PHY_1840;
	volatile u32 DENALI_PHY_1841;
	volatile u32 DENALI_PHY_1842;
	volatile u32 DENALI_PHY_1843;
	volatile u32 DENALI_PHY_1844;
	volatile u32 DENALI_PHY_1845;
	volatile u32 DENALI_PHY_1846;
	volatile u32 DENALI_PHY_1847;
	volatile u32 DENALI_PHY_1848;
	volatile u32 DENALI_PHY_1849;
	volatile u32 DENALI_PHY_1850;
	volatile u32 DENALI_PHY_1851;
	volatile u32 DENALI_PHY_1852;
	volatile u32 DENALI_PHY_1853;
	volatile u32 DENALI_PHY_1854;
	volatile u32 DENALI_PHY_1855;
	volatile u32 DENALI_PHY_1856;
	volatile u32 DENALI_PHY_1857;
	volatile u32 DENALI_PHY_1858;
	volatile u32 DENALI_PHY_1859;
	volatile u32 DENALI_PHY_1860;
	volatile u32 DENALI_PHY_1861;
	volatile u32 DENALI_PHY_1862;
	volatile u32 DENALI_PHY_1863;
	volatile u32 DENALI_PHY_1864;
	volatile u32 DENALI_PHY_1865;
	volatile u32 DENALI_PHY_1866;
	volatile u32 DENALI_PHY_1867;
	volatile u32 DENALI_PHY_1868;
	volatile u32 DENALI_PHY_1869;
	volatile u32 DENALI_PHY_1870;
	volatile u32 DENALI_PHY_1871;
	volatile u32 DENALI_PHY_1872;
	volatile u32 DENALI_PHY_1873;
	volatile u32 DENALI_PHY_1874;
	volatile u32 DENALI_PHY_1875;
	volatile u32 DENALI_PHY_1876;
	volatile u32 DENALI_PHY_1877;
	volatile u32 DENALI_PHY_1878;
	volatile u32 DENALI_PHY_1879;
	volatile u32 DENALI_PHY_1880;
	volatile u32 DENALI_PHY_1881;
	volatile u32 DENALI_PHY_1882;
	volatile u32 DENALI_PHY_1883;
	volatile u32 DENALI_PHY_1884;
	volatile u32 DENALI_PHY_1885;
	volatile u32 DENALI_PHY_1886;
	volatile u32 DENALI_PHY_1887;
	volatile u32 DENALI_PHY_1888;
	volatile u32 DENALI_PHY_1889;
	volatile u32 DENALI_PHY_1890;
	volatile u32 DENALI_PHY_1891;
	volatile u32 DENALI_PHY_1892;
	volatile u32 DENALI_PHY_1893;
	volatile u32 DENALI_PHY_1894;
	volatile u32 DENALI_PHY_1895;
	volatile u32 DENALI_PHY_1896;
	volatile u32 DENALI_PHY_1897;
	volatile u32 DENALI_PHY_1898;
	volatile u32 DENALI_PHY_1899;
	volatile u32 DENALI_PHY_1900;
	volatile u32 DENALI_PHY_1901;
	volatile u32 DENALI_PHY_1902;
	volatile u32 DENALI_PHY_1903;
	volatile u32 DENALI_PHY_1904;
	volatile u32 DENALI_PHY_1905;
	volatile u32 DENALI_PHY_1906;
	volatile u32 DENALI_PHY_1907;
	volatile u32 DENALI_PHY_1908;
	volatile u32 DENALI_PHY_1909;
	volatile u32 DENALI_PHY_1910;
	volatile u32 DENALI_PHY_1911;
	volatile u32 DENALI_PHY_1912;
	volatile u32 DENALI_PHY_1913;
	volatile u32 DENALI_PHY_1914;
	volatile u32 DENALI_PHY_1915;
	volatile u32 DENALI_PHY_1916;
	volatile u32 DENALI_PHY_1917;
	volatile u32 DENALI_PHY_1918;
	volatile u32 DENALI_PHY_1919;
	volatile u32 DENALI_PHY_1920;
	volatile u32 DENALI_PHY_1921;
	volatile u32 DENALI_PHY_1922;
	volatile u32 DENALI_PHY_1923;
} lpddr4_ctlregs;

#endif /* REG_LPDDR4_CTL_REGS_H_ */
